<template>
    <div class="mt-6">
        {{ $admin }}
        <div class="-intro-y flex justify-center space-x-2">
            <a
                v-for="key in Object.keys($helper.getLanguages())"
                :key="key"
                href="javascript:"
                @click="changeLocale($helper.getLanguages()[key])"
            >
                <img
                    :src="$helper.getLanguages()[key].flag"
                    class="h-6"
                >
            </a>
        </div>
        <custom-card
            :title="$appName"
            class="mx-4 my-6 px-2"
        >
            <div
                class="-intro-y mx-auto text-center"
            >
                <img
                    :src="'/img/logo.png'"
                    class="h-36 mx-auto text-center"
                >
            </div>
            <div
                class="intro-y"
            >
                <auto-form
                    ref="form"
                    :fields="fields"
                />
            </div>
            <div
                class="intro-y"
            >
                <auto-button
                    type="primary"
                    block
                    :disabled="form && form.busy ? form.busy : false"
                    @click="submitLogin"
                >
                    {{ $t('login') }}
                </auto-button>
            </div>
        </custom-card>
    </div>
</template>

<script setup>
import {inject, ref} from "vue";
import {useRouter} from 'vue-router';
import AutoForm from '~/components/auto-form.vue';
import CustomCard from "~/components/custom-card.vue";
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";
import {useAdminStore} from "~/stores/admin.js";
import {useLocaleStore} from "~/stores/locale.js";

const $router = useRouter();
const $helper = inject('$helper');
const {t} = useI18n();
const form = ref();
const fields = [
    {type: 'text', name: 'username', label: t('username'), placeholder: t('username')},
    {type: 'password', name: 'password', label: t('password'), placeholder: t('password')}
];

const $adminStore = useAdminStore();
const $admin = $adminStore.account;
const $localeStore = useLocaleStore();

const submitLogin = async () => {
    try {
        const resp = await form.value.submitForm('/login');
        await $helper.alertSuccess({
            message: resp.message,
            callback: async () => {
                await $adminStore.loginAccount(resp.token);
                // await $store.dispatch('admin/loginAdmin', resp.token);
                await $router.push({name: 'admin.home'});
            }
        });
    } catch (e) {
        console.log(e);
    }
}

const changeLocale = async (lang) => {
    await $localeStore.updateLocale(lang.locale);
}
</script>
